> This page is for API, version 2026-01-01 (Stable) (default).
> For other versions, use one of these documentation indexes:
> - 2026-01-01 (Stable) (default): https://developer.deel.com/api/stable/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.deel.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.deel.com/_mcp/server.

# Approve a visa application quote

POST https://api.letsdeel.com/rest/immigration/visa-application-quotes/{visa_application_quote_id}/approve

Approves a visa application quote in IN_REVIEW and opens the visa application case, returned as generated_case_id. An approved visa application quote cannot be approved again. Requires the visa application quote id returned from the List case visa application quotes endpoint.

 **Token scopes**: `immigration:write`

 **Beta**: this version requires the `X-Beta: true` request header and its contract may change before it is promoted to stable. It is scheduled to become stable on 2027-01-14.

Reference: https://developer.deel.com/api/reference/endpoints/immigration/approve-visa-application-quote-v-2026-10-14

## Authentication

- `Authorization` header (bearer token, required) — ## Authentication The Deel API uses bearer tokens to authenticate requests. All API calls must be made over HTTPS — calls over plain HTTP or without authentication will fail. ```curl curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \ -H 'Authorization: Bearer YOUR-TOKEN-HERE' ``` [Learn more about authentication](/api/authentication)
- `Authorization` header (bearer token, required) — Standard OAuth2 security scheme based on https://swagger.io/docs/specification/authentication/

## Servers

- `https://api.letsdeel.com/rest` (Production, default)
- `https://api-staging.letsdeel.com/rest` (Demo)

## Request

### Path parameters

- `visa_application_quote_id` (string, required) — The unique identifier of the visa application quote to approve.

### Headers

- `X-Beta` (enum, required, default: true) — Opts in to the beta version of this endpoint. Must be `true`.
  - Allowed values: `true`

## Response

### 200

Successful response with the approved visa application quote.

- `data` (ImmigrationVisaApplicationQuotesVisaApplicationQuoteIdApprovePostResponsesContentApplicationJsonSchemaData, required)

## Errors

### 400 Bad Request Error

Operation failed.

- `errors` (list of ImmigrationVisaApplicationQuotesVisaApplicationQuoteIdApprovePostResponsesContentApplicationJsonSchemaErrorsItems, optional)

### 401 Unauthorized Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 403 Forbidden Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 404 Not Found Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 500 Internal Server Error

Operation failed.

- `errors` (list of ImmigrationVisaApplicationQuotesVisaApplicationQuoteIdApprovePostResponsesContentApplicationJsonSchemaErrorsItems, optional)

## Types

### ImmigrationVisaApplicationQuotesVisaApplicationQuoteIdApprovePostResponsesContentApplicationJsonSchemaData

- `id` (string, required) — The unique identifier of the visa application quote.
- `items` (list of ImmigrationVisaApplicationQuotesVisaApplicationQuoteIdApprovePostResponsesContentApplicationJsonSchemaDataItemsItems, required) — The fees that make up the visa application quote.
- `status` (enum, required) — IN_REVIEW while the visa application quote waits for the organization to approve it, APPROVED once approved.
  - Allowed values: `IN_REVIEW`, `APPROVED`
- `case_id` (string, required) — The unique identifier of the eligibility check case the visa application quote was proposed on.
- `due_date` (string, required, nullable) — UTC timestamp by which the quoted fees are due once approved.
- `created_at` (string, required) — UTC timestamp when the visa application quote was created.
- `updated_at` (string, required) — UTC timestamp of the last change to the visa application quote.
- `description` (string, required, nullable) — Approval details of the visa application quote.
- `generated_case_id` (string, required, nullable) — The unique identifier of the visa application case opened when the visa application quote was approved. Null while it is in review.

### ImmigrationVisaApplicationQuotesVisaApplicationQuoteIdApprovePostResponsesContentApplicationJsonSchemaErrorsItems

- `code` (string, optional) — The error code.
- `message` (string, optional) — Human-readable explanation of the error.

### ApiErrorRequest

- `method` (string, optional) — The HTTP method of the failed request
- `url` (string, optional) — The relative URL of the failed request
- `status` (double, optional) — The status code of the response
- `api_req_id` (string, optional) — The request ID of the failed request
- `docs` (string, optional) — A link to the official documentation for the requested endpoint resource
- `source` (string, optional) — The source handler which produced the returned error
- `code` (double, optional) — The code of the source handler which produced the returned error

### ApiError

- `message` (string, optional) — A description of the returned error
- `path` (string, optional) — The JSON path where input validation failed

### ImmigrationVisaApplicationQuotesVisaApplicationQuoteIdApprovePostResponsesContentApplicationJsonSchemaDataItemsItems

- `name` (string, required, nullable) — Name of the quoted fee.
- `amount` (double, required) — Amount of the fee.
- `currency` (string, required) — ISO 4217 currency code of the fee.
- `description` (string, required, nullable) — Description of the quoted fee.

## Examples

**Response**

```json
{
  "data": {
    "id": "359d927c-f19f-4a32-92d1-751592448e22",
    "items": [
      {
        "name": "Government Fees",
        "amount": 300,
        "currency": "USD",
        "description": "Fees paid to the government for the visa application."
      }
    ],
    "status": "IN_REVIEW",
    "case_id": "8e4a849f-10e0-4052-8b58-ca75d9fc0e88",
    "due_date": "2026-11-15T00:00:00Z",
    "created_at": "2026-10-13T10:00:00Z",
    "updated_at": "2026-10-14T09:00:00Z",
    "description": "Work permit with fast-track processing",
    "generated_case_id": "0b7c7f0e-4f5e-4a8a-9d2b-5d6c1f0e9a11"
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.letsdeel.com/rest/immigration/visa-application-quotes/359d927c-f19f-4a32-92d1-751592448e22/approve"

headers = {
    "X-Beta": "true",
    "Authorization": "Bearer <token>"
}

response = requests.post(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/immigration/visa-application-quotes/359d927c-f19f-4a32-92d1-751592448e22/approve';
const options = {method: 'POST', headers: {'X-Beta': 'true', Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/immigration/visa-application-quotes/359d927c-f19f-4a32-92d1-751592448e22/approve"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("X-Beta", "true")
	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/immigration/visa-application-quotes/359d927c-f19f-4a32-92d1-751592448e22/approve")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Beta"] = 'true'
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/immigration/visa-application-quotes/359d927c-f19f-4a32-92d1-751592448e22/approve")
  .header("X-Beta", "true")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/immigration/visa-application-quotes/359d927c-f19f-4a32-92d1-751592448e22/approve', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'X-Beta' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/immigration/visa-application-quotes/359d927c-f19f-4a32-92d1-751592448e22/approve");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Beta", "true");
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Beta": "true",
  "Authorization": "Bearer <token>"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/immigration/visa-application-quotes/359d927c-f19f-4a32-92d1-751592448e22/approve")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```